/*
 * Khoros: $Id$
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * $Log$
 */ 

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                       <<<<
   >>>>		Attribute Table  			      <<<<
   >>>>                                                       <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  */

#include "internals.h"


AttributeEntry kvf_attribute_table[] = {

{0, KVF_ACTIVATE,	KINT,		kvf_get_activate,
					kvf_set_activate,		},
{0, KVF_SELECTED,	KINT,		kvf_get_selected,
					kvf_set_selected,		},
{0, KVF_OPTIONAL,   	KINT,		kvf_get_optional,
					kvf_set_optional,		},
{0, KVF_OPTSEL,	  	KINT,		kvf_get_optsel,
					kvf_set_optsel,			},
{0, KVF_LIVE,	  	KINT,		kvf_get_live,
					kvf_set_live,			},
{0, KVF_VARIABLE,	KSTRING,	kvf_get_variable,
					kvf_set_variable,		},
{0, KVF_DESCRIPTION, 	KSTRING,	kvf_get_description,
					kvf_set_description,		},
{0, KVF_TITLE,  	KSTRING,	kvf_get_title,
					kvf_set_title,			},
{0, KVF_BUTTONTITLE, 	KSTRING,	kvf_get_buttontitle,
					kvf_set_buttontitle,		},
{0, KVF_GUIDEPANETITLE, KSTRING,	kvf_get_guidepanetitle,
					kvf_set_guidepanetitle,		},
{0, KVF_LITERAL,	KSTRING,	kvf_get_literal,	
					kvf_set_literal,		},
{0, KVF_MODIFIED,	KINT,		kvf_get_modified,
					kvf_set_modified,		},
{0, KVF_WIDTH, 		KFLOAT,		kvf_get_width,
					kvf_set_width,			},
{0, KVF_HEIGHT,		KFLOAT,		kvf_get_height,
					kvf_set_height,			},
{0, KVF_X,		KFLOAT,		kvf_get_x,
					kvf_set_x,			},
{0, KVF_Y,		KFLOAT,		kvf_get_y,
					kvf_set_y,			},
{0, KVF_BUTTONWIDTH, 	KFLOAT,		kvf_get_buttonwidth,
					kvf_set_buttonwidth,		},
{0, KVF_BUTTONHEIGHT,	KFLOAT,		kvf_get_buttonheight,
					kvf_set_buttonheight,		},
{0, KVF_BUTTONX,	KFLOAT,		kvf_get_buttonx,
					kvf_set_buttonx,		},
{0, KVF_BUTTONY,	KFLOAT,		kvf_get_buttony,
					kvf_set_buttony,		},
{0, KVF_XPOS, 		KFLOAT,		kvf_get_xpos,
					kvf_set_xpos,			},
{0, KVF_YPOS, 		KFLOAT,		kvf_get_ypos,
					kvf_set_ypos,			},
{0, KVF_DELETE, 	KINT,		NULL,
					kvf_set_delete,			},
{0, KVF_WORKSPACE, 	KSTRUCT,	kvf_get_workspace,
					kvf_set_workspace,		},
{0, KVF_PRINT_UIS, 	KSTRING,	kvf_get_print_uis,
					kvf_set_print_uis,		},
{0, KVF_PRINT_PANE,	KSTRING,	kvf_get_print_pane,
					kvf_set_print_pane,		},
{0, KVF_PRINT_SUBFORM,	KSTRING,	kvf_get_print_subform,
					kvf_set_print_subform,		},
{0, KVF_UIS_LOCATION,	KSTRING,	kvf_get_uis_location,
					kvf_set_uis_location,		},
{0, KVF_CLIENTDATA,	KSTRUCT,	kvf_get_clientdata,
					kvf_set_clientdata,		},
{0, KVF_SUBFORM_FILE,	KSTRING,	kvf_get_subform_file,
					kvf_set_subform_file,		},
{0, KVF_PANE_FILE,	KSTRING,	kvf_get_pane_file,
					kvf_set_pane_file,		},
{0, KVF_DISPLAY_SUBFORM,KINT,		NULL,
					kvf_set_display_subform,	},
{0, KVF_DISPLAY_PANE,	KINT,		NULL,
					kvf_set_display_pane,		},
{0, KVF_ME_SUBFORMS,	KINT,		kvf_get_me_subforms,
					kvf_set_me_subforms,		},
{0, KVF_FILE_NAME,      KSTRING,	kvf_get_file_name,
					kvf_set_file_name,		},
{0, KVF_FILE_CHECK,     KINT,      	kvf_get_file_check,
					kvf_set_file_check,		},
{0, KVF_FILE_DEF,	KSTRING,	kvf_get_file_def,
					kvf_set_file_def,		},
{0, KVF_STRING_VAL, 	KSTRING,	kvf_get_string_val,
					kvf_set_string_val,		},
{0, KVF_STRING_DEF, 	KSTRING,	kvf_get_string_def,
					kvf_set_string_def,		},
{0, KVF_STRING_MULTILINE, KINT,		kvf_get_string_multiline,
					kvf_set_string_multiline,	},
{0, KVF_EXECTYPE,	 KINT,		kvf_get_exectype,
					kvf_set_exectype,		},
{0, KVF_ROUTINE,	KSTRING,	kvf_get_routine,
					kvf_set_routine,		},
{0, KVF_HELPPATH,	KSTRING,	kvf_get_help_path,
					kvf_set_help_path,		},
{0, KVF_TOGGLE_SIZE,    KINT,	        kvf_get_toggle_size,
					kvf_set_toggle_size, 	        },
{0, KVF_TOGGLE_NUM,	KINT,       	kvf_get_toggle_num,
					kvf_set_toggle_num,		},
{0, KVF_TOGGLE_VAL,	KSTRING,       	kvf_get_toggle_val,
					kvf_set_toggle_val,		},
{0, KVF_TOGGLE_TYPE, 	KINT,	        kvf_get_toggle_type,
					NULL,				},
{0, KVF_TOGGLE_CONTENTS, KSTRUCT,       kvf_get_toggle_contents,
					NULL,				},
{0, KVF_TOGGLE_CONTENTS_DESC, KSTRUCT,  kvf_get_toggle_contents_desc,
					NULL,				},
{0, KVF_LOGIC_VAL, 	KINT,	        kvf_get_logic_val,
					kvf_set_logic_val,		},
{0, KVF_LOGIC_DEF, 	KINT,	        kvf_get_logic_def,
					kvf_set_logic_def,		},
{0, KVF_LOGIC_1LABEL, 	KSTRING,	kvf_get_logic_label,
					kvf_set_logic_label,		},
{0, KVF_LOGIC_0LABEL, 	KSTRING,	kvf_get_logic_label,
					kvf_set_logic_label,		},
{0, KVF_LOGIC_LABEL, 	KSTRING,	kvf_get_logic_label,
					kvf_set_logic_label,		},
{0, KVF_LIST_SIZE,	KINT,     	kvf_get_list_size,
					kvf_set_list_size,		},
{0, KVF_LIST_VAL,	KINT, 		kvf_get_list_val,
					kvf_set_list_val,		},
{0, KVF_LIST_ITEM,	KSTRING, 	kvf_get_list_item,
					kvf_set_list_item,		},
{0, KVF_LIST_LABEL,     KSTRING,   	kvf_get_list_label,
					kvf_set_list_label,		},
{0, KVF_LIST_INDEX,     KINT,   	kvf_get_list_index,
					kvf_set_list_index,		},
{0, KVF_LIST_START,  	KINT,      	kvf_get_list_start,
					kvf_set_list_start,		},
{0, KVF_LIST_CONTENTS,  KSTRUCT,    	kvf_get_list_contents,
					kvf_set_list_contents,		},
{0, KVF_LIST_DOUBLECLICK, KINT,       	kvf_get_list_doubleclick,
					kvf_set_list_doubleclick,	},
{0, KVF_LIST_ADD,   	KINT, 	    	NULL,
					kvf_set_list_add,		},
{0, KVF_LIST_DELETE,    KINT,	    	NULL,
					kvf_set_list_delete,		},
{0, KVF_LIST_DELETEALL, KINT,	    	NULL,
					kvf_set_list_deleteall,		},
{0, KVF_VAL_LABELS,  	KSTRUCT,    	kvf_get_val_labels,
					NULL,				},
{0, KVF_INT_GT0_SEL, 	KINT, 	    	kvf_get_int_gt0_sel,
					kvf_set_int_gt0_sel,		},
{0, KVF_INT_GE0_SEL,  	KINT,	    	kvf_get_int_ge0_sel,
					kvf_set_int_ge0_sel,		},
{0, KVF_INT_LT0_SEL, 	KINT, 	    	kvf_get_int_lt0_sel,
					kvf_set_int_lt0_sel,		},
{0, KVF_INT_LE0_SEL,  	KINT,	    	kvf_get_int_le0_sel,
					kvf_set_int_le0_sel,		},
{0, KVF_INT_BOUNDS_SEL, KINT,	    	kvf_get_bounds_sel,
					kvf_set_bounds_sel,		},
{0, KVF_INT_NOBOUNDS_SEL, KINT,      	kvf_get_nobounds_sel,
					kvf_set_nobounds_sel,		},
{0, KVF_INT_UPPER,      KINT,	        kvf_get_int_upper,
					kvf_set_int_upper,		},
{0, KVF_INT_LOWER,      KINT,	        kvf_get_int_lower,
					kvf_set_int_lower,		},
{0, KVF_INT_DEF, 	KINT,           kvf_get_int_def,
					kvf_set_int_def,		},
{0, KVF_INT_VAL, 	KINT,     	kvf_get_int_val,
					kvf_set_int_val,		},
{0, KVF_MECHANISM, 	KINT,     	kvf_get_mechanism,
					kvf_set_mechanism,		},
{0, KVF_FLOAT_GT0_SEL, 	KINT, 	    	kvf_get_float_gt0_sel,
					kvf_set_float_gt0_sel,		},
{0, KVF_FLOAT_GE0_SEL, 	KINT, 	    	kvf_get_float_ge0_sel,
					kvf_set_float_ge0_sel,		},
{0, KVF_FLOAT_LT0_SEL, 	KINT, 	    	kvf_get_float_lt0_sel,
					kvf_set_float_lt0_sel,		},
{0, KVF_FLOAT_LE0_SEL, 	KINT, 	    	kvf_get_float_le0_sel,
					kvf_set_float_le0_sel,		},
{0, KVF_FLOAT_BOUNDS_SEL, KINT, 	kvf_get_bounds_sel,
					kvf_set_bounds_sel,		},
{0, KVF_FLOAT_NOBOUNDS_SEL, KINT,    	kvf_get_nobounds_sel,
					kvf_set_nobounds_sel,		},
{0, KVF_FLOAT_UPPER,    KFLOAT, 	kvf_get_float_upper,
					kvf_set_float_upper,		},
{0, KVF_FLOAT_LOWER,   	KFLOAT,   	kvf_get_float_lower,
					kvf_set_float_lower,		},
{0, KVF_FLOAT_DEF,    	KFLOAT,  	kvf_get_float_def,
					kvf_set_float_def,		},
{0, KVF_FLOAT_VAL,	KFLOAT,      	kvf_get_float_val,
					kvf_set_float_val,		},
{0, KVF_FLOAT_PREC,    	KINT,  	        kvf_get_precision,
					kvf_set_precision,		},
{0, KVF_DOUBLE_GT0_SEL, KINT,	    	kvf_get_double_gt0_sel,
					kvf_set_double_gt0_sel,		},
{0, KVF_DOUBLE_GE0_SEL, KINT, 	    	kvf_get_double_ge0_sel,
					kvf_set_double_ge0_sel,		},
{0, KVF_DOUBLE_LT0_SEL,  KINT,	    	kvf_get_double_lt0_sel,
					kvf_set_double_lt0_sel,		},
{0, KVF_DOUBLE_LE0_SEL,  KINT,	    	kvf_get_double_le0_sel,
					kvf_set_double_le0_sel,		},
{0, KVF_DOUBLE_BOUNDS_SEL, KINT,  	kvf_get_bounds_sel,
					kvf_set_bounds_sel,		},
{0, KVF_DOUBLE_NOBOUNDS_SEL, KINT,     	kvf_get_nobounds_sel,
					kvf_set_nobounds_sel,		},
{0, KVF_DOUBLE_UPPER,   KDOUBLE,   	kvf_get_double_upper,
					kvf_set_double_upper,		},
{0, KVF_DOUBLE_LOWER,   KDOUBLE,  	kvf_get_double_lower,
					kvf_set_double_lower,		},
{0, KVF_DOUBLE_DEF,  	KDOUBLE,     	kvf_get_double_def,
					kvf_set_double_def,		},
{0, KVF_DOUBLE_VAL,  	KDOUBLE,    	kvf_get_double_val,
					kvf_set_double_val,		},
{0, KVF_DOUBLE_PREC,   	KINT,           kvf_get_precision,
					kvf_set_precision,		},
};

/*
 * note that kvf_attribute_num has to be defined in the same file
 * as the kvf_attribute_table definition, or knumber will not work right.
 */
int kvf_attribute_num = knumber(kvf_attribute_table);
